-- SDLEX06.EX
-- Input events demo

include file.e
include machine.e
include Sdl_Wrap.e
include misc.e

atom format,pixels
atom dummy
atom surface,buffer
atom done
atom keystate
atom d1,d2,d3,ball
atom srect,drect
integer x1,y1
integer x2,y2
integer x3,y3
integer xb,yb,xxb,yyb
integer nj
atom stick
atom mx,my
atom ts

function abs(integer i)
    if i<0 then
        return -i
    else
        return i 
    end if
end function

dummy = SDL_Init(SDL_INIT_VIDEO)
if dummy = -1 then
    puts(1, "SDL_Init had a hissy fit!\n")
end if

dummy = SDL_InitSubSystem(SDL_INIT_JOYSTICK)
if dummy = -1 then
    puts(1, "SDL_InitSubSystem had a hissy fit!\n")
end if

surface = SDL_SetVideoMode(640,480,16,SDL_FULLSCREEN)
--surface = SDL_SetVideoMode(640,480,16,SDL_RESIZABLE)

format=peek4u(surface+4)
pixels=peek4u(surface+20)

buffer = SDL_ConvertSurface(surface,format,SDL_HWSURFACE)

d1=SDL_LoadBMP("Bitmaps/jstick.bmp")
d2=SDL_LoadBMP("Bitmaps/mouse.bmp")
d3=SDL_LoadBMP("Bitmaps/keys.bmp")
ball=SDL_LoadBMP("Bitmaps/Ball1.bmp")

srect=allocate(8)
drect=allocate(8)

mx=allocate(4)
my=allocate(4)

x1=0
y1=0
x3=500
y3=400
xb=54
yb=125
xxb=4
yyb=4

nj=SDL_NumJoysticks()
if nj>0 then
    stick=SDL_JoystickOpen(0)
end if

dummy=SDL_ShowCursor(SDL_DISABLE)
if dummy = -1 then
    puts(1, "SDL_ShowCursor had a hissy fit!\n")
end if
dummy=SDL_SetColorKey(d1,SDL_SRCCOLORKEY,SDL_MapRGB(format,0,0,0))
if dummy = -1 then
    puts(1, "SDL_SetColorKey had a hissy fit!\n")
end if
dummy=SDL_SetColorKey(d2,SDL_SRCCOLORKEY,SDL_MapRGB(format,0,0,0))
if dummy = -1 then
    puts(1, "SDL_SetColorKey had a hissy fit!\n")
end if
dummy=SDL_SetColorKey(d3,SDL_SRCCOLORKEY,SDL_MapRGB(format,0,0,0))
if dummy = -1 then
    puts(1, "SDL_SetColorKey had a hissy fit!\n")
end if
dummy=SDL_SetColorKey(ball,SDL_SRCCOLORKEY,SDL_MapRGB(format,0,0,0))
if dummy = -1 then
    puts(1, "SDL_SetColorKey had a hissy fit!\n")
end if

-- use the PumpEvents and GetMouseState to see if a mouse button has been pressed
done=0    
while done=0 do
    dummy=SDL_FillRect(buffer,NULL,0)
    SDL_PumpEvents()
    keystate=SDL_GetKeyState(NULL)
    if peek(keystate+SDLK_ESCAPE)>0 then
        done=1        
    end if
    if peek(keystate+SDLK_UP)>0 then
        y3=y3-2
        if y3<0 then
            y3=431    
        end if
    end if
    if peek(keystate+SDLK_DOWN)>0 then
        y3=y3+2
        if y3>431 then
            y3=0    
        end if
    end if
    if peek(keystate+SDLK_LEFT)>0 then
        x3=x3-2
        if x3<0 then
            x3=575    
        end if
    end if
    if peek(keystate+SDLK_RIGHT)>0 then
        x3=x3+2
        if x3>575 then
            x3=0    
        end if
    end if
    SDL_PumpEvents()
    dummy=SDL_GetMouseState(mx,my)
    if dummy = -1 then
        puts(1, "SDL_GetMouseState had a hissy fit!\n")
    end if
    if dummy!=0 then
        done=1
    end if
    
    xb=xb+xxb
    if xb>619 then
        xb=619
        xxb=-xxb    
    end if
    if xb<0 then
        xb=0
        xxb=-xxb
    end if
    yb=yb+yyb
    if yb>459 then
        yb=459
        yyb=-yyb        
    end if
    if yb<0 then
        yb=0
        yyb=-yyb
    end if
    
    x2=peek(mx)+256*peek(mx+1)
    y2=peek(my)+256*peek(my+1)
    
    if nj>0 then
        ts=SDL_JoystickGetAxis(stick,0)
        if ts>32768 then
            ts=-65536+ts
--            ts=-ts    
        end if
        x1=floor(((ts/32768)*300)+320)
        ts=SDL_JoystickGetAxis(stick,1)
        if ts>32768 then
            ts=-65536+ts
--            ts=-ts    
        end if
        y1=floor(((ts/32768)*220)+240)    
    end if
    
    if (abs((x1+32)-(xb+10))+abs((y1+24)-(yb+10)))<24  then
        xxb=-xxb
        yyb=-yyb    
    end if

    if (abs((x2+32)-(xb+10))+abs((y2+24)-(yb+10)))<24  then
        xxb=-xxb
        yyb=-yyb    
    end if

    if (abs((x3+32)-(xb+10))+abs((y3+24)-(yb+10)))<24  then
        xxb=-xxb
        yyb=-yyb    
    end if

    poke(srect,{0,0,0,0,64,0,48,0})
    poke(drect,{0,0,0,0,64,0,48,0})
    poke(drect,remainder(x1,256))      
    poke(drect+1,floor(x1/256))      
    poke(drect+2,remainder(y1,256))      
    poke(drect+3,floor(y1/256))      
    dummy=SDL_BlitSurface(d1,srect,buffer,drect)
    if dummy = -1 then
        puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
    end if
    poke(srect,{0,0,0,0,64,0,48,0})
    poke(drect,{0,0,0,0,64,0,48,0})
    poke(drect,peek({mx,2}))      
    poke(drect+2,peek({my,2}))      
    dummy=SDL_BlitSurface(d2,srect,buffer,drect)
    if dummy = -1 then
        puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
    end if
    poke(srect,{0,0,0,0,64,0,48,0})
    poke(drect,{0,0,0,0,64,0,48,0})
    poke(drect,remainder(x3,256))      
    poke(drect+1,floor(x3/256))      
    poke(drect+2,remainder(y3,256))      
    poke(drect+3,floor(y3/256))      
    dummy=SDL_BlitSurface(d3,srect,buffer,drect)
    if dummy = -1 then
        puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
    end if
    poke(srect,{0,0,0,0,20,0,20,0})
    poke(drect,{0,0,0,0,20,0,20,0})
    poke(drect,remainder(xb,256))      
    poke(drect+1,floor(xb/256))      
    poke(drect+2,remainder(yb,256))      
    poke(drect+3,floor(yb/256))      
    dummy=SDL_BlitSurface(ball,srect,buffer,drect)
    if dummy = -1 then
        puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
    end if
    dummy=SDL_BlitSurface(buffer,NULL,surface,NULL)
    if dummy = -1 then
        puts(1, "SDL_GetBlitSurface had a hissy fit!\n")
    end if
    SDL_UpdateRect(surface,0,0,0,0)
end while

if nj>0 then
    SDL_JoystickClose(stick)
end if

-- We're done with them.. Free the surfaces
SDL_FreeSurface(surface)
SDL_FreeSurface(buffer)
SDL_FreeSurface(d1)
SDL_FreeSurface(d2)
SDL_FreeSurface(d3)
SDL_FreeSurface(ball)
free(srect)
free(drect)

SDL_QuitSubSystem(SDL_INIT_JOYSTICK)

-- quit SDL
SDL_Quit()


